'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TEXT = 'text';
var PASSWORD = 'password';
var HIDE_LABEL = 'hide';
var SHOW_LABEL = 'show';

var Password = function (_React$Component) {
  (0, _inherits3.default)(Password, _React$Component);

  function Password() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Password);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Password.__proto__ || (0, _getPrototypeOf2.default)(Password)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      type: PASSWORD,
      value: ''
    }, _this.toggle = function () {
      var type = _this.state.type;

      var inputType = type === PASSWORD ? TEXT : PASSWORD;

      _this.setState({ type: inputType });
    }, _this.onChange = function (ev, _ref2) {
      var value = _ref2.value;

      _this.setState({ value: value }, function () {
        var onChange = _this.props.onChange;

        onChange && onChange(ev, { value: value });
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Password, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          pwShowLabel = _props.pwShowLabel,
          pwHideLabel = _props.pwHideLabel,
          props = (0, _objectWithoutProperties3.default)(_props, ['pwShowLabel', 'pwHideLabel']);
      var _state = this.state,
          type = _state.type,
          value = _state.value;


      return _react2.default.createElement(
        'div',
        { className: 'sui-AtomInput-password' },
        _react2.default.createElement(_Input2.default, (0, _extends3.default)({}, props, { onChange: this.onChange, value: value, type: type })),
        _react2.default.createElement(
          'div',
          {
            onClick: this.toggle,
            className: 'sui-AtomInput-password--toggleButton'
          },
          type === PASSWORD ? pwShowLabel : pwHideLabel
        )
      );
    }
  }]);
  return Password;
}(_react2.default.Component);

Password.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /* Text to be shown in order to show the password on click */
  pwShowLabel: _propTypes2.default.string,
  /* Text to be shown in order to hide the password on click */
  pwHideLabel: _propTypes2.default.string,
  /* Event launched on every input change */
  onChange: _propTypes2.default.func,
  /* The name of the control */
  name: _propTypes2.default.string,
  /* The id of the control */
  id: _propTypes2.default.string
} : {} : {};

Password.defaultProps = {
  pwShowLabel: SHOW_LABEL,
  pwHideLabel: HIDE_LABEL
};

exports.default = Password;